#include "main.h"
//------------------------------------------------------------------------------
//---- Init function -----------------------------------------------------------
//------------------------------------------------------------------------------

int InitSystem(void)
{
	InitUART( 25 ); /* Set the baudrate to 38400 bps using a 16MHz crystal */
	printf("ATmega128 is online...\n");
	printf("Configuring 32k SRAM...\n");
	
	printf("MCUCR has the following value: %d\n", MCUCR);
	printf("XMCRA has the following value: %d\n", XMCRA);
	printf("XMCRB has the following value: %d\n", XMCRB);
	printf("\n");
	printf("32k SRAM is now active...\n");
	printf("\n");
	printf("Checking RAM...\n");
	return true;
}

void CeckRam(void) {
	int testVar[2048];
	//int testVar2[1024];
	
	printf("\nPlease press 'a' to continue\n");
	
	while (ReceiveByte() != 'a') {}
	
	printf("Try to fill SRAM with something...\n");
	
	for (int16_t i = 0; i <= 2048; i++){
			testVar[i] = i;
			//printf("%d ", testVar[i]);
	}
	printf("\n");
			
	printf("Print the whole variable...\n");
	
	printf("\nPlease press 'a' to continue\n");
	
	while (ReceiveByte() != 'a') {}
	
	for (int16_t i = 0; i <= 2048; i++){
			if (testVar[i] == i)
				printf("%d ", testVar[i]);
			else
				printf("Error at adress: %d with value %d, should be %d", (i), testVar[i], i);
	}
	printf("\n");
	
	printf("\nPlease press 'a' to continue\n");
	
	while (ReceiveByte() != 'a') {}
	
	for (int16_t i = 0; i <= 2048; i++){
		printf("%d ", &testVar[i]);
	}
	printf("\n");
	
	/*for (int16_t i = 0; i <= 1024; i++){
		printf("%d ", &testVar2[i]);
	}*/
	printf("\n");
	
	printf("Done checking...\n");
}

//------------------------------------------------------------------------------
//---- Main function -----------------------------------------------------------
//------------------------------------------------------------------------------

int main(void)
{
	//MCUCR = 0x80; // wurde ber den Assambler bereits getan
	XMCRA = 0x00;
	XMCRB = 0x81;
	
	InitSystem(); 				// Reset IO's
	CeckRam();
	
	while(1){
		;
	}
	
	return 0;
}
